/* -----------------------------------------------------------------------------
	RcxNg֐
	t@C	:	vec3d.as
	as.Ver		:	Flash 5 ȍ~
			:	Hakuhin	(C)	2006/05/11
 ----------------------------------------------------------------------------- */

/* -----------------------------------------------------------------------------

	--------------------------------------
	xNǧ^

	vec = {
		x : 0,	y : 0,	z : 0
	};
	--------------------------------------

	RcxNgIuWFNg`ŕ\Ă܂B
	x  x ̐A y  y ̐Az  z ̐łB

	--------------------------------------
	֐ꗗ

	function Vec3dCreate(x,y,z);			// RcxNg쐬
	function Vec3dClone(vec);				// RcxNg
	function Vec3dAdd(vec1, vec2);			// RcxNgm̉Z
	function Vec3dSub(vec1, vec2);			// RcxNgm̌Z
	function Vec3dScale(vec, scale);		// RcxNg̏Z
	function Vec3dDotProduct(vec1, vec2);	// RcxNgm̓
	function Vec3dCrossProduct(vec1, vec2);	// RcxNgm̊O
	function Vec3dLength(vec);				// RcxNg̒
	function Vec3dNormalize (vec)			// RcxNg̐K
	--------------------------------------

 ----------------------------------------------------------------------------- */


/* ------------------------------------------------------------------- 
	xNg쐬
	01	x 
	02	y 
	03	z 
	Ԃl		xNgiIuWFNgj

	(gp)
	var 	vec = _root.Vec3dCreate(10,5,2);
 ------------------------------------------------------------------- */
function Vec3dCreate(x,y,z){
	return {
		x : x,
		y : y,
		z : z
	};
}


/* ------------------------------------------------------------------- 
	xNg
	01	xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var 	vec1 = _root.Vec2dCreate(10,5);
	var 	vec2 = _root.Vec3dClone(vec1);
 ------------------------------------------------------------------- */
function Vec3dClone(vec){
	return {
		x : vec.x,
		y : vec.y,
		z : vec.z
	};
}


/* ------------------------------------------------------------------- 
	xNgZ
	01	Pڂ̃xNg
	02	Qڂ̃xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec3dCreate(10,5,2);
	var vec2 = _root.Vec3dCreate(20,-7,3);	
	var vec3 = _root.Vec3dAdd(vec1,vec2);
 ------------------------------------------------------------------- */
function Vec3dAdd( vec1, vec2 ){
	return {
		x : vec1.x + vec2.x,
		y : vec1.y + vec2.y,
		z : vec1.z + vec2.z
	};
}


/* ------------------------------------------------------------------- 
	xNgZ
	01	Pڂ̃xNg
	02	Qڂ̃xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec3dCreate(10,5,2);
	var vec2 = _root.Vec3dCreate(20,-7,3);	
	var vec3 = _root.Vec3dSub(vec1,vec2);
 ------------------------------------------------------------------- */
function Vec3dSub( vec1, vec2 ){
	return {
		x : vec1.x - vec2.x,
		y : vec1.y - vec2.y,
		z : vec1.z - vec2.z
	};
}


/* ------------------------------------------------------------------- 
	XJlŏZ
	01	Pڂ̃xNg
	02	{
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec3dCreate(10,5,2);	
	var vec2 = _root.Vec3dScale(vec1,2);
 ------------------------------------------------------------------- */
function Vec3dScale( vec, scale ){
	return {
		x : vec.x * scale,
		y : vec.y * scale,
		z : vec.z * scale
	};
}


/* ------------------------------------------------------------------- 
	
	01	Pڂ̃xNg
	02	Qڂ̃xNg
	Ԃl		

	(gp)
	var vec1 = _root.Vec3dCreate(10,5,2);
	var vec2 = _root.Vec3dCreate(20,-7,3);
	var dot = _root.Vec3dDotProduct(vec1,vec2);
 ------------------------------------------------------------------- */
function Vec3dDotProduct( vec1, vec2 ){
	return ((vec1.x * vec2.x) + (vec1.y * vec2.y) + (vec1.z * vec2.z));		
}


/* ------------------------------------------------------------------- 
	O
	01	Pڂ̃xNg
	02	Qڂ̃xNg
	Ԃl		xNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec3dCreate(10,5,2);
	var vec2 = _root.Vec3dCreate(20,-7,3);
	var vec3 = _root.Vec3dCrossProduct(vec1,vec2);
 ------------------------------------------------------------------- */
function Vec3dCrossProduct( vec1, vec2 ){
	return {
		x : (vec1.y * vec2.z) - (vec1.z * vec2.y),
		y : (vec1.z * vec2.x) - (vec1.x * vec2.z),
		z : (vec1.x * vec2.y) - (vec1.y * vec2.x)
	};
}


/* ------------------------------------------------------------------- 
	xNg̒
	01	𒲂ׂxNg
	Ԃl		

	(gp)
	var vec1 = _root.Vec3dCreate(10,5,2);	
	var length = _root.Vec3dLength(vec1);
 ------------------------------------------------------------------- */
function Vec3dLength( vec ){
	return Math.sqrt((vec.x * vec.x) + (vec.y * vec.y) + (vec.z * vec.z));
}


/* ------------------------------------------------------------------- 
	xNg̐K
	01	KxNg
	Ԃl		KꂽxNgiIuWFNgj

	(gp)
	var vec1 = _root.Vec3dCreate(10,5,2);
	var vec2 = _root.Vec3dNormalize(vec1);
 ------------------------------------------------------------------- */
function Vec3dNormalize ( vec ){
   var length = Math.sqrt((vec.x * vec.x) + (vec.y * vec.y) + (vec.z * vec.z));
	if(length > 0)	length = 1 / length;
	return {
		x : vec.x * length,
		y : vec.y * length,
		z : vec.z * length
	};
}